# -*- coding:utf-8 -*-
from CatsBtPythonStrategy import CatsBtPythonStrategy
from CatsBtPythonStrategy import BackTestType

'''继承该类，并实现里面的on_xxx函数即可完成一个策略类
'''


class ICatsBtPythonStrategy(CatsBtPythonStrategy):
    def init(self, data, nlen):
        return 0

    def on_init(self):
        return 0

    def on_session_begin(self, date):
        return 0

    def on_session_end(self, date):
        return 0

    def on_replay_done(self):
        pass

    def on_tick(self, data):
        pass

    def on_tran(self, data):
        pass

    def on_bar(self, data):
        pass

    def on_order(self, data):
        pass

    def on_trade(self, data):
        pass

    def on_entrust(self, orderno, bsuccess, message, arg):
        pass

    def on_cancel(self, orderno, bsuccess, message, arg):
        pass

    def infolog_porter(self, to_console, info):
        super().infolog_porter(to_console, info)

    def warnlog_c(self, to_console, info):
        super().warnlog_c(to_console, info)

    def errorlog_c(self, to_console, info):
        super().errorlog_c(to_console, info)

    def sub_ticks(self, symbol):
        return super().sub_ticks(symbol)

    def unsub_ticks(self, symbol):
        return super().unsub_ticks(symbol)

    def sub_transaction(self, symbol):
        return super().sub_transaction(symbol)

    def unsub_transaction(self, symbol):
        return super().unsub_transaction(symbol)

    def sub_bars(self, symbol):
        return super().sub_bars(symbol)

    def unsub_bars(self, symbol):
        return super().unsub_bars(symbol)

    def submit_order(self, req, arg=None):
        return super().submit_order(req, arg)

    def cancel_order(self, orderno, acctType, acct, arg=None):
        return super().cancel_order(orderno, acctType, acct, arg)

    def init_fund(self, beginBalance, acct_type, acct):
        return super().init_fund(beginBalance, acct_type, acct)

    def init_fund_and_fee(self, beginBalance, open_comn, sell_comn, min_comn, open_tax, sell_tax, acct_type, acct,
                          money_type="0"):
        return super().init_fund_and_fee(beginBalance, open_comn, sell_comn, min_comn, open_tax, sell_tax, acct_type,
                                         acct, money_type)

    def get_fund(self, fundlist, acctType, acct):
        return super().get_fund(fundlist, acctType, acct)

    def init_position(self, symbol, qty, cost, acct_type="", acct="", long_short=""):
        return super().init_position(symbol, qty, cost, acct_type, acct, long_short)

    def get_positions(self, poslist, acctType, acct):
        return super().get_positions(poslist, acctType, acct)

    def load_table(self, tablename, instruments, startdate, enddate, fields, cond, tables):
        return super().load_table(tablename, instruments, startdate, enddate, fields, cond, tables)

    def load_table_to_json(self, tablename, instruments, startdate, enddate, fields, cond, buffer_size=0):
        return super().load_table_to_json(tablename, instruments, startdate, enddate, fields, cond, buffer_size)

    def get_tick_slice(self, symbol, startDate, startTime, endDate, endTime):
        return super().get_tick_slice(symbol, startDate, startTime, endDate, endTime)

    def get_bar_slice(self, symbol, startDate, startTime, endDate, endTime):
        return super().get_bar_slice(symbol, startDate, startTime, endDate, endTime)

    def get_YYYYMMDD(self):
        return super().get_YYYYMMDD()

    def get_HHMMSSsss(self):
        return super().get_HHMMSSsss()

    def set_start_end_time(self, start_hhmmss, end_hhmmss, is_cross_night=False):
        super().set_start_end_time(start_hhmmss, end_hhmmss, is_cross_night)

    def set_start_end_day(self, start_day, end_day):
        super().set_start_end_day(start_day, end_day)

    def get_start_end_day(self, start_day, end_day):
        super().get_start_end_day(start_day, end_day)

    def sub_trade(self, acct_type, acct):
        super().sub_trade(acct_type, acct)

    def sub_order(self, acct_type, acct):
        super().sub_order(acct_type, acct)

    def set_debug(self, is_debug):
        super().set_debug(is_debug)

    def set_benchmark(self, benchmark):
        super().set_benchmark(benchmark)

    def set_backtest_type(self, backtest_type: BackTestType):
        super().set_backtest_type(backtest_type)

    def set_log_data_flag(self, data_type, v):
        super().set_log_data_flag(data_type, v)

    def load_table_to_data_frame(self, tablename, instruments, startdate, enddate, fields, cond):
        return super().load_table_to_data_frame(tablename, instruments, startdate, enddate, fields, cond)

    def get_dominant_future(self, future_id_short):
        return super().get_dominant_future(future_id_short)

    def get_future_contracts(self, future_id_short):
        return super().get_future_contracts(future_id_short)

    def get_instance_dir(self):
        return super().get_instance_dir()
