/************************************************************************/
/*  ˵
ļӦ CATSBTSample ࣬ʵ ICATSStrategy еĻܣزĻҪ

sampleҪʾʵһز࣬Լʹûزṩĺ

1ÿtick¼Ϊ׼¼+0.01Ϊһ¼+0.01Ϊһ
2µݲ
3ʱݲ
*/
/************************************************************************/

#include "catsbtsample.h"
#include "../include/ICATSCtx.h"
#include "../include/CATSBTDataDefine.h"


using namespace std;
static string acct_type = "S0";
static string acct = "bt00000";

static string future_acct_type = "A";
static string future_acct = "bt11111";

int HHMMSS_diff(int before_hhmmss, int after_hhmmss)
{
	int before_ss = (before_hhmmss % 100);
	int before_mm = (before_hhmmss / 100) % 100;
	int before_hh = (before_hhmmss / 10000);

	int after_ss = (after_hhmmss % 100);
	int after_mm = (after_hhmmss / 100) % 100;
	int after_hh = (after_hhmmss / 10000);

	return (after_hh * 3600 + after_mm * 60 + after_ss) - (before_hh * 3600 + before_mm * 60 + before_ss);
}


static void query_funds_timer(void *arg)
{
	CATSBTSample *sample = (CATSBTSample*)arg;
	sample->query_fund_timer();
}

static void query_positions_timer(void *arg)
{
	CATSBTSample *sample = (CATSBTSample*)arg;
	sample->query_position_timer();
}


CATSBTSample::CATSBTSample()
	:m_last_cancel_time(0)
	, m_last_order_time(0)
	, m_cancel_cnt(0)
{
	m_cancel_order_secs = 10;
	m_order_interval = 30;
	m_order_count = 100;
}

CATSBTSample::~CATSBTSample()
{
}



void CATSBTSample::string_split(const std::string& str, const std::string& delims , unsigned int maxSplits , vector<string>& results)
{
	unsigned int numSplits = 0;

	// Use STL methods
	size_t start, pos;
	start = 0;
	do
	{
		pos = str.find_first_of(delims, start);
		if (pos == start)
		{
			results.emplace_back("");
			// Do nothing
			start = pos + 1;
		}
		else if (pos == std::string::npos || (maxSplits && numSplits == maxSplits))
		{
			// Copy the rest of the std::string
			results.emplace_back(str.substr(start));
			break;
		}
		else
		{
			// Copy up to delimiter
			results.emplace_back(str.substr(start, pos - start));
			start = pos + 1;
		}
		// parse up to next real data
		//start = str.find_first_not_of(delims, start);
		++numSplits;

	} while (pos != std::string::npos);
}


/************************************************************************/
/* ʼʵ
   ڸúҪʵĳʼ

*/
/************************************************************************/
int CATSBTSample::init(ICATSPrepareCtx* prepare_ctx, map<string, string> params)
{
	//BEGIN  ûز⿪ʼںͽ, ڳãôͲýϹѡ
	int start_day = 0;
	int end_day = 0;
	if (params.find("start_day") != params.end())
	{
		start_day = atoi(params["start_day"].c_str());
	}

	if (params.find("end_day") != params.end())
	{
		end_day = atoi(params["end_day"].c_str());
	}
	
	if (start_day != 0)
	{
		if (end_day == 0)
		{
			prepare_ctx->errorlog(true, "start_day is set, while end_day is not set");
			return 1;
		}

		prepare_ctx->infolog(true, "start_day:%d, end_day:%d", start_day, end_day);
		int ret = prepare_ctx->set_start_end_day(start_day, end_day);
		if (ret != 0)
		{
			prepare_ctx->errorlog(true, "failed to set start day and end day");
			return ret;
		}
	}
	//END  ûز⿪ʼںͽ

	//BEGIN  ׼ز ûԶлȡò
	string codes = "600000.SH";
	if (params.find("symbols") != params.end())
	{
		codes = params["symbols"];		
	}
	prepare_ctx->infolog(true, "codes:%s", codes.c_str());

	string_split(codes, ",", 0, m_symbol_list);
	if (m_symbol_list.size() == 0)
	{
		prepare_ctx->infolog(true, "there is no symbol");
		return -1;
	}
	//END  ׼ز
	
	//BEGIN ÿʼͽʱ䣬úֻʵ壬زиúԶ
	int ret = prepare_ctx->set_start_end_time(83600, 0, false);
	if (ret != 0)
	{
		return ret;
	}
	//END ÿʼͽʱ
	prepare_ctx->infolog(true, "init called");
	return 0;
}


int CATSBTSample::on_init(ICATSCtx* ctx)
{
	m_ctx = ctx;
	m_ctx->infolog(true, "on_init called");

	int start_day = 0;
	int end_day = 0;
	//ctx->get_start_end_day(start_day, end_day);
	ctx->infolog(true, "start_day:%d, end_day:%d", start_day, end_day);


	//BEGIN tickʼĵĳֲϢ
	for (int i = 0; i < m_symbol_list.size(); i++)
	{
		int ret = m_ctx->sub_ticks(m_symbol_list[i].c_str());
		if (ret != 0)
		{
			return ret;
		}

		ret = m_ctx->init_position(m_symbol_list[i], 1000000000, 20.1f, acct_type, acct);
		if (ret != 0)
		{
			return ret;
		}
	}
	int ret = m_ctx->init_fund(100000000000.0, acct_type, acct);
	if (ret != 0)
	{
		return ret;
	}
	//END tickʼĵĳֲϢ ʽϢ

	//BEGIN ûĶʳɽ زлԶûĶûĶʳɽʵҪʾȥġ
	m_ctx->sub_trade(acct_type, acct);
	m_ctx->sub_order(acct_type, acct);
	//END ûĶʳɽ


	//BEGIN  Ӷʱ
	//1ÿ10ѯһʽ2
	m_ctx->add_timer(1000000, false, query_funds_timer, this);
	m_ctx->add_timer(5000000, false, query_positions_timer, this);

	//m_ctx->sub_ticks("IF2110.CFFEX");

	//for index future 
	//ret = m_ctx->init_position("IF2110.CFFEX", 100, 3400, future_acct_type, future_acct, "2");
	if (ret != 0)
	{
		m_ctx->errorlog(true, "failed to init position for index future, ret:%d", ret);
		return ret;
	}
	//ret = m_ctx->init_position("IF2110.CFFEX", 100, 3400, future_acct_type, future_acct, "3");
	if (ret != 0)
	{
		m_ctx->errorlog(true, "failed to init position for index future, ret:%d", ret);
		return ret;
	}

	//ret = m_ctx->init_fund(100000000000.0, future_acct_type, future_acct);
	if (ret != 0)
	{
		m_ctx->errorlog(true, "failed to init fund for index future, ret:%d", ret);
		return ret;
	}

	//END  Ӷʱ
	return 0;
}

/************************************************************************/
/* µɹʧܵĻصú override  ICATSStrategy::on_entrust 
*/
/************************************************************************/
void CATSBTSample::on_entrust(const char* orderNo, bool is_success, const char* message, void *arg)
{
	int idx = *((int*)arg);
	delete (int*)arg;
	if (!is_success)
	{
		m_ctx->errorlog(true, "failed to submit order, reason:%s", message);
		return;
	}	
	m_ctx->infolog(false, "succeed to submit order, order no : %s, idx:%d", orderNo, idx);
	m_orders.insert(orderNo);
}

/************************************************************************/
/* ɹʧܵĻصú override  ICATSStrategy::on_cancel 
*/
/************************************************************************/
void CATSBTSample::on_cancel(const char* orderNo, bool is_success, const char* message, void *arg)
{
	int idx = *((int*)arg);
	delete (int*)arg;

	if (!is_success)
	{
		m_ctx->errorlog(true, "failed to cancel order, reason:%s", message);
		return;
	}
	m_ctx->infolog(false, "succeed to cancel order, order no : %s, idx:%d", orderNo, idx);
}



/************************************************************************/
/* tick
*/
/************************************************************************/
void CATSBTSample::on_tick(CATSBTTickData* newTick)
{
	static int submit_order_idx = 0;

	string code = newTick->code();

	//
	float price = newTick->price();
	if (price < 0.01)
	{
		return;
	}

	int current_time = m_ctx->get_HHMMSSsss() / 1000;
	if (current_time < 93000)
	{
		return;
	}
	
	check_and_cancel_orders();
	
	
	int diff = HHMMSS_diff(m_last_order_time, current_time);
	if (diff < m_order_interval)
	{
		return;
	}
	m_last_order_time = current_time;

	vector<string> tmps;
	string_split(code, ".", 0, tmps);
	if (tmps.size() < 2)
	{
		m_ctx->errorlog(false, "invalid symbol: %s", code.c_str());
		return;
	}
	string exchange = tmps[1];

	//for A-share
	if (exchange.compare("SH") == 0 || exchange.compare("SZ") == 0)
	{
		//buy		
		{
			OrderRequest orderRequest;
			orderRequest.acct = acct;
			orderRequest.acctType = acct_type;
			orderRequest.symbol = code;
			orderRequest.qty = m_order_count;
			orderRequest.priceType = "0";

			float targetPx = newTick->price() - 0.01f;// 22.0; // price - 0.01 * 1;
			orderRequest.price = targetPx;
			orderRequest.tradeSide = "1"; //buy 
			orderRequest.reamrks = "hello_" + orderRequest.tradeSide;
			submit_order_idx++;
			int *p = new int;
			*p = submit_order_idx;
			m_ctx->submit_order(orderRequest, p);
		}
		//sell
		{
			OrderRequest orderRequest;
			orderRequest.acct = acct;
			orderRequest.acctType = acct_type;
			orderRequest.symbol = code;
			orderRequest.qty = m_order_count;
			orderRequest.priceType = "0";

			float targetPx = newTick->price() + 0.01f;

			orderRequest.price = targetPx; //targetPx;
			orderRequest.tradeSide = "2"; //sell
			orderRequest.reamrks = "hello_" + orderRequest.tradeSide;

			submit_order_idx++;
			int *p = new int;
			*p = submit_order_idx;
			m_ctx->submit_order(orderRequest, p);
		}
	}
	else //for index-future
	{
		//buy		ƽ
		{
			OrderRequest orderRequest;
			orderRequest.acct = future_acct;
			orderRequest.acctType = future_acct_type;
			orderRequest.symbol = code;
			orderRequest.qty = 1;
			orderRequest.priceType = "0";

			float targetPx = newTick->price() - 0.01f;// 22.0; // price - 0.01 * 1;
			orderRequest.price = targetPx;
			orderRequest.tradeSide = "FC"; //buy 
			orderRequest.reamrks = "hello_f" + orderRequest.tradeSide;
			submit_order_idx++;
			int *p = new int;
			*p = submit_order_idx;
			m_ctx->submit_order(orderRequest, p);
		}
		//sell 	ƽ
		{
			OrderRequest orderRequest;
			orderRequest.acct = future_acct;
			orderRequest.acctType = future_acct_type;
			orderRequest.symbol = code;
			orderRequest.qty = 1;
			orderRequest.priceType = "0";

			float targetPx = newTick->price() + 0.01f;

			orderRequest.price = targetPx; //targetPx;
			orderRequest.tradeSide = "FD"; //sell
			orderRequest.reamrks = "hello_f" + orderRequest.tradeSide;

			submit_order_idx++;
			int *p = new int;
			*p = submit_order_idx;
			m_ctx->submit_order(orderRequest, p);
		}
	}
}

/************************************************************************/
/* ÿһʱ鲢δɵĶ ʱʱԵʱ
   Ƕɵʱ
*/
/************************************************************************/
void CATSBTSample::check_and_cancel_orders()
{
	static int cancel_order_idx = 0;
	uint32_t current_time = m_ctx->get_HHMMSSsss() / 1000;
	if (m_last_cancel_time == 0)
	{
		m_last_cancel_time = current_time;
		return;
	}

	if (m_orders.empty())
	{
		return;
	}

	uint32_t diff = HHMMSS_diff(m_last_cancel_time, current_time);
	if (diff < m_cancel_order_secs)
	{
		return;
	}
	m_last_cancel_time = current_time;

	m_ctx->infolog(false, "go to cancel unfinished orders that submitted %d seconds ago", m_cancel_order_secs);
	for (auto orderNo : m_orders)
	{	
		cancel_order_idx++;
		int *p = new int;
		*p = cancel_order_idx;
		m_ctx->cancel_order(orderNo, acct_type, acct, p);
	}
}

/************************************************************************/
/* ÿճʱִһ
*/
/************************************************************************/
int CATSBTSample::on_session_begin(int date)
{
	m_ctx->infolog(true, "on_session_begin called");
	m_last_order_time = 0;
	m_last_cancel_time = 0;

	return 0;
}


/************************************************************************/
/* ÿʱִһ
*/
/************************************************************************/
int CATSBTSample::on_session_end(int date)
{
	m_orders.clear();
	m_ctx->infolog(true, "on_session_end called");

	/*
	vector<CATSBTBarStruct> bars;
	int ret = m_ctx->get_bar_slice(bars, "600000.SH", date - 1, 93000000, date, 94000000);
	for (const auto &bar : bars) {
		m_ctx->infolog(true, bar.toString().c_str());
	}
	*/
	vector<CATSBTTickStruct> ticks;
	int ret = m_ctx->get_tick_slice(ticks, "600000.SH", date - 1, 93000000, date, 94000000);
	for (const auto &tick : ticks) {
		m_ctx->infolog(true, tick.toString().c_str());
	}

	return 0;
}

/************************************************************************/
/* زʱһ
*/
/************************************************************************/
void CATSBTSample::on_replay_done()
{
	m_ctx->infolog(true, "on_replay_done called");
}

void CATSBTSample::on_bar(CATSBTBarData * bar)
{
	m_ctx->infolog(false, "on_bar, bar:%s", bar->toString().c_str());
}

/************************************************************************/
/* ûʳɽ
*/
/************************************************************************/
void CATSBTSample::on_trade(const TradeData data)
{
}


/************************************************************************/
/* ûı
*/
/************************************************************************/
void CATSBTSample::on_order(const OrderUpdateData data)
{
	int leftQty = data.orderQty - data.filledQty;
	if (data.isFinished())
	{
		m_orders.erase(data.orderNo);
	}
}

/************************************************************************/
/* ûѯʽʱص
*/
/************************************************************************/
void CATSBTSample::query_fund_timer()
{
	m_ctx->infolog(false, "go to query fund");
	vector<Fund> funds(0);	
	int ret = m_ctx->get_funds(funds, acct_type, acct);
	if (ret != 0)
	{
		m_ctx->errorlog(false, "failed to query fund, ret:%d", ret);
		return;
	}

	for (int i = 0; i < funds.size(); i++)
	{
		m_ctx->infolog(false, "FUND:%s", funds[i].toString().c_str());
	}
}


/************************************************************************/
/* ûѯֲֶʱص
*/
/************************************************************************/
void CATSBTSample::query_position_timer()
{
	m_ctx->infolog(false, "go to query position");
	map<string, Position> positions;
	int ret = m_ctx->get_positions(positions, "", acct_type, acct);
	if (ret != 0)
	{
		m_ctx->errorlog(false, "failed to query fund, ret:%d", ret);
		return;
	}

	map<string, Position>::iterator xx = positions.begin();
	while (xx != positions.end())
	{
		m_ctx->infolog(false, "batch : POS:symbol:%s, details:%s", xx->first.c_str(), xx->second.toString().c_str());
		xx++;
	}


	positions.clear();
	ret = m_ctx->get_positions(positions, "600000.SH", acct_type, acct);
	if (ret != 0)
	{
		m_ctx->errorlog(false, "failed to query fund, ret:%d", ret);
		return;
	}

	xx = positions.begin();
	while (xx != positions.end())
	{
		m_ctx->infolog(false, "single : POS:symbol:%s, details:%s", xx->first.c_str(), xx->second.toString().c_str());
		xx++;
	}
}


