#pragma once
#include <unordered_set>
#include <vector>


#include "../include/CATSBTMarcos.h"
#include "../include/ICATSCtx.h"
#include "../include/ICATSStrategy.h"

USING_NS_OTP;

#if defined(__cplusplus) || defined(c_plusplus)
extern "C" {
#endif



class CATSBTSample : public ICATSStrategy
{
public:
	CATSBTSample();
	~CATSBTSample();

public:

	int init(ICATSPrepareCtx* prepare_ctx, map<string, string> params) override;

	virtual int on_init(ICATSCtx* ctx) override;
	virtual int on_session_begin(int uTDate) override;
	virtual int on_session_end(int uTDate) override;
	virtual void on_replay_done() override;

	virtual void on_bar(CATSBTBarData* bar) override;

	virtual void on_tick(CATSBTTickData* newTick) override;
	
	virtual void on_trade(const TradeData data) override;

	virtual void on_order(const OrderUpdateData data) override;

	virtual void on_entrust(const char* orderNo, bool is_success, const char* message, void *arg) override;

	virtual void on_cancel(const char* orderNo, bool is_success, const char* message, void *arg) override;
	void	check_and_cancel_orders();

	void query_fund_timer();

	void query_position_timer();
private:
	
	void string_split(const std::string& str, const std::string& delims , unsigned int maxSplits, vector<string>& results);

private:
	ICATSCtx*	m_ctx;
	vector<string> m_symbol_list;
	uint32_t		m_cancel_order_secs;
	int		m_order_interval;

	typedef std::unordered_set<std::string> IDSet;
	IDSet      m_orders;
	int  m_order_count;

	uint32_t		m_last_cancel_time;
	uint32_t		m_last_order_time;
	bool			m_channel_ready;
	uint32_t		m_cancel_cnt;
};


#if defined(__cplusplus) || defined(c_plusplus)
}
#endif

