
#pragma once
#include <stdint.h>
#include <atomic>
#include "CATSBTMarcos.h"

NS_OTP_BEGIN
class CATSBTObject
{
public:
	CATSBTObject() :m_uRefs(1){}
	virtual ~CATSBTObject(){}

public:
	uint32_t		retain(){ return m_uRefs.fetch_add(1) + 1; }

	virtual void	release()
	{
		if (m_uRefs == 0)
			return;

		try
		{
			uint32_t cnt = m_uRefs.fetch_sub(1);
			if (cnt == 1)
				delete this;
		}
		catch(...)
		{

		}
	}

	bool			isSingleRefs() { return m_uRefs == 1; }

	uint32_t		retainCount() { return m_uRefs; }

protected:
	volatile std::atomic<uint32_t>	m_uRefs;
};

NS_OTP_END
