#pragma once
#include <vector>
#include "CATSBTMarcos.h"

using namespace std;

NS_OTP_BEGIN

enum DataFieldType
{
	DFT_None,          // unknown
	DFT_Int8,          // one bytes
	DFT_Int16,         // tow bytes
	DFT_Int32,
	DFT_Int64,
	DFT_Float32,
	DFT_Float64,
	DFT_Ptr,
	DFT_Str,
	DFT_Object
};

struct DataField
{
	string name;
	string value;
	DataFieldType type;

	DataField()
	{
		memset(this, 0, sizeof(DataField));
	}
};

struct DataRow
{
	int ncol;
	vector<DataField> fields;
};

struct DataTable
{
	int nrow;
	int ncol;
	vector<DataRow> rows;
};

NS_OTP_END;