
#pragma once
#include <string>
#include <map>
#include <set>
#include "CATSBTMarcos.h"
#include "CATSBTDataDefine.h"
#include "CATSBTMD.h"
#include "CATSBTWindData.h"

#if defined(__cplusplus) || defined(c_plusplus)
extern "C" {
#endif

NS_OTP_BEGIN


//׼ӿ, 
class EXPORT_FLAG ICATSPrepareCtx
{
public:

	/************************************************************************/
	/* òԵʱ䣬ùҪ initеã
	ز⣺úڻز塣
	      زаյһtickΪÿտʱ䣬һtickΪÿս 
	ʵ̣Ҫͻڲеøúͽʱ
	start_hhmmsshhmmss, 0ʾϵͳʱԣϣ102030
	              ô start_hhmmss Ϊ 102030
	end_hhmmss:hhmmss, Ϊ0ʾ2359:59ʱϣ112030
	              ô end_hhmmss Ϊ 112030ҹô end_hhmmss  start_hhmmss
	is_cross_nightǷֿ֧ҹ
	*/
	/************************************************************************/
	virtual int set_start_end_time(int start_hhmmss, int end_hhmmss, bool is_cross_night = false) = 0;


	/************************************************************************/
	/* ûزԵĿʼںͽڣزΪ [ start_day, end_day] , 
	   ڿͻ˽ãҲͨӿãԳΪ׼
	   ùҪ initеã
	ز⣺ûزԵĿʼںͽ
	ʵ̣õʵ
	start_dayYYYYMMDD, 
	end_day : YYYYMMDD, ܳ죬δĳһ죬ϵͳԶΪ죬 end_dayڵstart_day
	*/
	/************************************************************************/
	virtual int set_start_end_day(int start_day, int end_day) = 0;


	/************************************************************************/
	/* ȡزĿʼںͽ
	ز⣺ȡزԵĿʼںͽ
	ʵ̣õʵ
	start_dayYYYYMMDD,
	end_day : YYYYMMDD
	*/
	/************************************************************************/
	virtual void get_start_end_day(int& start_day, int& end_day) = 0;


	/************************************************************************/
	/* ûز׼
	õıĲֻ֧߸ʽ⣬طֵ
	ҪInitصʱãطЧ
	symbolģָҲǹƱ
	*/
	/************************************************************************/
	virtual int set_benchmark(const char* symbol) = 0;

	/************************************************************************/
	/* ûز
	õĻزͲֻ֧߸ʽ⣬طֵ
	ҪInitصʱãطЧ
	typeز
	*/
	/************************************************************************/
	virtual int set_backtest_type(BackTestType type) = 0;

	/************************************************************************/
	/* ûزг
	õĻزгֻ֧߸ʽ⣬طֵ
	ҪInitصʱãطЧ
	marketsAAɣHK۹
	*/
	/************************************************************************/
	virtual int set_market(string market) = 0;


	/************************************************************************/
	/* ȡĵƷϢ 
		ȡıĲֻ֧߸ʽ⣬طֵ
	symbol 
	info  Ϣ
	*/
	/************************************************************************/
	virtual int get_commodity_info(const char* symbol, CommodityInfo& info) = 0;


	/************************************************************************/
	/* ôӡ־Ϣ                                                                     
	   data_type:
	    0:ӡеϢ
	    1:ڻزдӡOrderUpdate
		2:ڻزдӡTradeUpdate
     	3: ڻزдӡ(tick/transaction/minbar)
		4: ڻزÿһϢʽ𣬳ֲ֣
	*/
	/************************************************************************/
	virtual void set_log_data_flag(int data_type, bool v) = 0;

	/************************************************************************/
	/* д־ܣ־ͬʱļͽ
	   to_console: ΪtrueļҲĻֻļ
	*/
	/************************************************************************/
	virtual void infolog(bool to_console, const char* fmt, ...) = 0;
	virtual void warnlog(bool to_console, const char* fmt, ...) = 0;
	virtual void errorlog(bool to_console, const char* fmt, ...) = 0;	
};



//Խӿ
class EXPORT_FLAG ICATSCtx : public ICATSPrepareCtx
{
public:
	/************************************************************************/
	/* µӿ
	   زʱµᱨ
	   arg: µ󣬸òظص
	*/
	/************************************************************************/
	virtual int    submit_order(const OrderRequest request, void *arg=NULL) = 0;


	/************************************************************************/
	/* ӿ
	   زʱµᱨ
	   
	   order_no: 
	   acct_type:ʽ  Ʊ"0"β"S0"ڻ"A"β"SA" ͬ
	   acct: Ҫʽ˺, زʱһַʵʱʵ˺š ͬ
	   arg:󣬴ظص  on_cancel
	*/ 
	/************************************************************************/
	virtual int     cancel_order(std::string order_no, std::string acct_type, std::string acct, void *arg=NULL) = 0;
	

	/************************************************************************/
	/* ȡ
	  20121021գ򷵻20121021
	*/
	/************************************************************************/
	virtual uint32_t get_YYYYMMDD() = 0;


	/************************************************************************/
	/* ȡʱ䣬ȷ룬
	   102030400룬򷵻102030400
	*/
	/************************************************************************/
	virtual uint32_t get_HHMMSSsss() = 0;

	/************************************************************************/
	/* /ȡķ
	ڻز⣺زͱΪMINUTEֻon_initжĳĵʷ飬ʧ	          
	ʵ̣
	*/
	/************************************************************************/
	virtual int sub_bars(const char* symbol) = 0;
	virtual int unsub_bars(const char* symbol) = 0;


	/************************************************************************/
	/* /ȡ
	   ڻز⣺زͱΪTICKֻon_initжĳĵʷ飬ʧ
	   ʵ̣ʵʱ飬ҲҪʷ飬ôҲᶩʷ
	*/
	/************************************************************************/
	virtual int sub_ticks(const char* symbol) = 0;
	virtual int unsub_ticks(const char * symbol) = 0;

	/************************************************************************/
	/* /ȡʳɽ
	ڻز⣺زͱΪTickֻon_initжĳĵʷʳɽ飬ʧ
	ʵ̣ʵвֶ֧ʳɽ
	*/
	/************************************************************************/
	virtual int sub_transaction(const char* symbol) = 0;
	virtual int unsub_transaction(const char* symbol) = 0;

	/************************************************************************/
	/* load_table ΪȡWindݱӿ 
		table_name: Windݱ'AShareEODPrices'
		instruments: Ʊб['000009.SZ','600000.SH']
		start_date: ʼڣʽΪyyyy-mm-ddǸƵݣTickݺTransactionݣʽΪyyyy-mm-dd hh:mm:ss,Яʱ룬ĬΪyyyy-mm-dd 00:00:00
		end_date: ڣʽΪyyyy-mm-ddǸƵݣTickݺTransactionݣʽΪyyyy-mm-dd hh:mm:ss,Яʱ룬ĬΪyyyy-mm-dd 00:00:00
		fields: ֶб['s_info_name','s_info_list_date']
	*/
	/************************************************************************/
	virtual int load_table(DataTable &table, string table_name, string instruments, string start_date, string end_date, string fields, string cond, int datasource = 0) = 0;
	virtual int load_table(string &json, string table_name, string instruments, string start_date, string end_date, string fields, string cond, int datasource = 0) = 0;

	/************************************************************************/
	/* ʼֲ
		symbol: Ʊ룬'600030.SH'
		qty: 
		cost: ÿɳɱ24.55
		acct_type˻ͣƱ"0"β"S0"ڻ"A"β"SA"ֵĬΪƱ
		acctʽ˺
		longShortڻרãΪ"2"ղΪ"3"
	*/
	/************************************************************************/
	virtual int init_position(string symbol, int qty, float cost, string acct_type, string acct, string longShort = "") = 0;

	/************************************************************************/
	/* ȡֲϢ
	   symbol:Ϊַʾѯ˺ŵеĳֲֻ֣ѯñĳֲϢ
	   acctTypeʵʱʵ˺ͣزʱԲ
	   acctʵʱʵ˺ţزʱԲ
	*/
	/************************************************************************/
	virtual int get_positions(map<string, Position>& pos_map, string symbol, string acct_type, string acct) = 0;
	
	
	/************************************************************************/
	/* ʼʽ
		beginBalance: ʼʽڻΪʼ֤
	*/
	/************************************************************************/
	virtual int init_fund(double begin_balance, string acct_type, string acct ) = 0;


	/************************************************************************/
	/* ʼʽ
	beginBalance: ʼʽڻΪʼ֤
	openComn: 루֣Ӷ
	sellComn: ƽ֣Ӷ
	minComn: Ӷ
	openTax: 루֣˰
	sellTax: ƽ֣˰
	moneyType: Ϊ࣬"0"ʾңĿǰֻ֧
	*/
	/************************************************************************/
	virtual int init_fund(double begin_balance, double openComn, double sellComn, double minComn, double openTax, double sellTax, string acct_type, string acct, string moneyType="0") = 0;


	/************************************************************************/
	/* ȡʽϢ
	   ز⣺زֻһ¼
	   ʵ̣ʵʱһʽ˺ſܴڶʽĿ󲿷ֻһ¼
	*/
	/************************************************************************/
	virtual int get_funds(vector<Fund>&funds, string acct_type , string acct ) = 0;
		
	
	/************************************************************************/
	/* ȡʳɽƬṩʾȡ׵Ƭ	
		symbol: Ʊ룬'600030.SH'
		start_date: ʼڣʽΪyyyymmdd'20140327'
		start_time: ʼʱ䣬ʱ侫ȷ룬ʽΪhhmmssfff105932000
		end_date: ڣʽΪyyyymmdd'20140327'
		start_time: ʱ䣬ʱ侫ȷ룬ʽΪhhmmssfff105932000
	*/
	/************************************************************************/
	virtual int get_trans_slice(vector<CATSBTTransStruct> &ticks, string symbol, uint32_t start_date, uint32_t start_time, uint32_t end_date, uint32_t end_time) = 0;
	virtual int get_trans_slice(vector<CATSBTTransStruct> &ticks, string symbol, uint32_t start_time, uint32_t end_time) = 0;

	/****************************************************************************************/
	/* ȡƬṩʾȡ׵Ƭ	
		symbol: Ʊ룬'600030.SH'
		start_date: ʼڣʽΪyyyymmdd'20140327'
		start_time: ʼʱ䣬ʱ侫ȷ룬ʽΪhhmmssfff105932000
		end_date: ڣʽΪyyyymmdd'20140327'
		start_time: ʱ䣬ʱ侫ȷ룬ʽΪhhmmssfff105932000
	*/
	/****************************************************************************************/	
	virtual int get_tick_slice(vector<CATSBTTickStruct> &ticks, string symbol, uint32_t start_date, uint32_t start_time, uint32_t end_date, uint32_t end_time) = 0;
	virtual int get_tick_slice(vector<CATSBTTickStruct> &ticks, string symbol, uint32_t start_time, uint32_t end_time) = 0;

	/****************************************************************************************/
	/* ȡBarƬṩʾȡ׵Ƭ
	symbol: Ʊ룬'600030.SH'
	start_date: ʼڣʽΪyyyymmdd'20140327'
	start_time: ʼʱ䣬ʱ侫ȷ룬ʽΪhhmmssfff105932000
	end_date: ڣʽΪyyyymmdd'20140327'
	start_time: ʱ䣬ʱ侫ȷ룬ʽΪhhmmssfff105932000
	*/
	/****************************************************************************************/
	virtual int get_bar_slice(vector<CATSBTBarStruct> &bars, string symbol, uint32_t start_date, uint32_t start_time, uint32_t end_date, uint32_t end_time) = 0;
	virtual int get_bar_slice(vector<CATSBTBarStruct> &bars, string symbol, uint32_t start_time, uint32_t end_time) = 0;

	/************************************************************************/
	/* ʱ
	   interval : λ
	   immediately_callback: Ƿִ
	   func: ص
	   return:  timer id ,Сڵ0  ʾʧ
	   ע⣺֮¿ʼһεʱ䣬ҪڻصдʱϳĹ
	*/
	/************************************************************************/
	virtual int add_timer(int interval, bool immediately_callback, INTERVAL_CALLBACK_FUNC func, void *arg) = 0;


	/************************************************************************/
	/* ȡʱ
	*/
	/************************************************************************/
	virtual int cancel_timer(int timer_id) = 0;


	/************************************************************************/
	/*ºڻز壬ʵбãΪ˻ز֮ܲκ޸ľ
	  תΪʵУڻزʱ͵º
	  sub_trade
	  sub_order
	*/
	/************************************************************************/

	/************************************************************************/
	/* Ķĳɽͣ ùܽҪ on_initеãܻᵼ¶ʧɽ
	ز⣺زĬϻͣԲõ
	ʵ̣Ҫͻڲеøúжģûжɽ
	acct_type: ʽ˺
	acct:ʽ˺

	ע⣺ֻͱʵĶɽ
	*/
	/************************************************************************/
	virtual int sub_trade(std::string acct_type, std::string acct) = 0;

	/************************************************************************/
	/* Ķ״̬ͣ ùܽҪ on_initеãܻᵼ¶ʧ
	ز⣺زĬϻͣԲõ
	ʵ̣Ҫͻڲеøúжģûж
	acct_type: ʽ˺
	acct:ʽ˺
	ע⣺ֻͱʵĶ״̬
	*/
	/************************************************************************/
	virtual int sub_order(std::string acct_type, std::string acct) = 0;

	
	/************************************************************************/
	/* ȡԼصǰڻƷֵԼ
	ز⣺
	ʵ̣
	future_id_short:ΪƷ"IF.CFFEX", "IH.CFFEX", "IC.CFFEX"
	*/
	/************************************************************************/
	virtual int get_dominant_future(string future_id_short, string & dominant_symbol) = 0;


	/************************************************************************/
	/* ȡɽ׺ԼбظԼпɽ׵ĺԼ
	ز⣺
	ʵ̣
	future_id_short: ΪƷΪ"IF00.CFFEX""IF01.CFFEX""IF02.CFFEX""IF03.CFFEX"ʱ
	𷵻ص¡¡μĺԼ룬Ϊ"IF.CFFEX"ʱصǰƷпɽ׵ĺԼ
	*/
	/************************************************************************/
	virtual int get_future_contracts(string future_id_short, set<string> & symbols) = 0;


	/************************************************************************/
	/* ȡִʵĿ¼
	ز⣺
	ʵ̣
	ƶִʱĿ¼µݽԶͬ
	*/
	/************************************************************************/
	virtual int get_instance_dir(string &instance_dir) = 0;


	/************************************************************************/
	/* תծתɲ
	ز⣺
	ʵ̣
	*/
	/************************************************************************/
	virtual int submit_ccbond_convert(string symbol, int qty, string acctType, string acct) = 0;


	/************************************************************************/
	/* ȡתծɴ
	ز⣺
	ʵ̣
	*/
	/************************************************************************/
	virtual int get_ccbond_comp_symbol(string ccbond_symbol, string &symbol) = 0;
};

NS_OTP_END;

#if defined(__cplusplus) || defined(c_plusplus)
}
#endif

