# -*- coding:utf-8 -*-
from ICatsBtPythonStrategy import ICatsBtPythonStrategy
from CatsBtPythonStrategy import CatsBtPythonStrategy, OrderRequest, Fund, Position, DataTable, BackTestType


class PythonStrategyDemo(ICatsBtPythonStrategy):
    lastPrice = 0
    to_console = False
    ordersUnFinish = {}
    acctType = "S0"
    acct = "bt00000"
    count = 0
    clOrderNo = 0
    clOrderNos = dict()

    def next_clOrderNo(self):
        self.clOrderNo = self.clOrderNo + 1
        return "clOrderNo-" + str(self.clOrderNo)

    def init(self, data, nlen):
        # self.infolog_c(self.to_console, "init>>>>>>>>>>>>")
        super().set_log_data_flag(0, True)
        i = 0
        while i < nlen:
            self.infolog_c(self.to_console,
                           "Python strategy,init_param: name=" + data[i].name.decode() + " value=" + data[
                               i].value.decode() + " type=" + str(data[i].type))
            i = i + 1

        # self.set_backtest_type(BackTestType.MINUTE)
        # self.set_benchmark("000016.SH")
        # self.set_debug(True)
        return 0

    def on_init(self):
        # self.infolog_c(self.to_console, "on_init>>>>>>>>>>>>")
        super().sub_bars("600000.SH")
        super().sub_ticks("600000.SH")
        self.infolog_c(self.to_console, "PYTHON strategy: sub_ticks successful: symbol=600000.SH")
        # self.init_fund(1000000, "S0", "bt00000")
        self.init_fund_and_fee(1000000, 0, 0, 0, 0, 0.001, "S0", "bt00000")
        self.init_position("600000.SH", 100000, 9, "S0", "bt00000")

        fund = Fund()
        fundlist = []
        fundlist.append(fund)
        for i in range(1):
            ret0 = super().get_fund(fundlist, "S0", "bt00000")
            if ret0 == 0:
                self.infolog_c(self.to_console, "get_fund success")
            else:
                self.infolog_c(self.to_console, "get_fund fail")

        positionlist2 = []
        ret = super().get_positions(positionlist2, "S0", "bt00000")
        if ret == 0:
            self.infolog_c(self.to_console, "get_positions success")
        else:
            self.infolog_c(self.to_console, "get_positions fail")

        # self.test_load_data()

        return 0

    def on_session_begin(self, date):
        self.infolog_c(self.to_console, "on_session_begin >>>>>>>>>>>>")
        # self.test_load_data_to_data_frame()
        '''
        tables = [DataTable()]
        ret = super().load_table("AShareEODPrices", "600000.SH", "2021-07-01", "2021-07-10", "", "", tables)
        table = tables[0]
        if ret == 0:
            if len(table.rows) > 0:
                for i in range(len(table.rows)):
                    rowStr = ""
                    row = table.rows[i]
                    for j in range(len(row.fields)):
                        rowStr = rowStr + row.fields[j].name
                        rowStr = rowStr + "="
                        rowStr = rowStr + row.fields[j].value
                        if j < len(row.fields) - 1:
                            rowStr = rowStr + ","
                    self.infolog_c(self.to_console, "load_data >>>>>>>>>>>>row[" + str(i) + "]=" + rowStr)
        else:
            self.infolog_c(self.to_console, "load_data:failed, ret=" + ret)
        self.get_tick_slice("600000.SH", date, 91500000, date, 150000000)
        '''

        return 0

    def on_session_end(self, date):
        self.infolog_c(self.to_console, "on_session_end >>>>>>>>>>>>")

        # bars = self.get_bar_slice("600000.SH", date, 94000000, date, 95000000)
        # if bars is not None:
        #     for bar in bars:
        #         self.infolog_c(self.to_console, bar.toString())

        # self.test_get_tick_slice(date)

        return 0

    def on_replay_done(self):
        self.infolog_c(self.to_console, "on_replay_done >>>>>>>>>>>>")

    def on_bar(self, data):
        self.infolog_c(True, "on_bar >>>>>>>>>>>>" + data.toString())
        current = super().get_HHMMSSsss() / 1000
        if current < 93000:
            return

        self.count = self.count + 1
        if self.count % 5 != 0:
            return

        req = OrderRequest()
        req.acctType = self.acctType
        req.acct = self.acct
        req.symbol = data.code
        req.qty = 100
        req.priceType = "0"

        if data.close == self.lastPrice:
            return
        elif data.close < self.lastPrice:
            req.tradeSide = '1'
            req.price = data.close - 0.01
        elif data.close > self.lastPrice:
            req.tradeSide = '2'
            req.price = data.close + 0.01

        req.clOrderNo = self.next_clOrderNo()
        ret = super().submit_order(req)
        if ret == 0:
            self.infolog_c(self.to_console, "PYTHON strategy: submit_order success.")
            self.clOrderNos[req.clOrderNo] = ""
        else:
            self.infolog_c(self.to_console, "PYTHON strategy: submit_order failed.")

        self.lastPrice = data.close

        time = super().get_HHMMSSsss()
        # self.lock.acquire()
        # try:
        for key in self.ordersUnFinish.keys():
            if self.ordersUnFinish[key] - time > 5000:
                ret = super().cancel_order(key, self.acctType, self.acct)
                if ret == 0:
                    self.infolog_c(self.to_console, "PYTHON strategy: cancel_order success.")
                else:
                    self.infolog_c(self.to_console, "PYTHON strategy: cancel_order failed.")

    def on_tick(self, data):
        # self.infolog_c(self.to_console, "on_tick >>>>>>>>>>>>")

        current = super().get_HHMMSSsss()/1000
        if current < 93000:
            return

        self.count = self.count + 1
        if self.count % 5 != 0:
            return

        req = OrderRequest()
        req.acctType = self.acctType
        req.acct = self.acct
        req.symbol = data.code
        req.qty = 100
        req.priceType = "0"
        if data.price == self.lastPrice:
            return
        elif data.price < self.lastPrice:
            req.tradeSide = '1'
            req.price = data.price - 0.01
        elif data.price > self.lastPrice:
            req.tradeSide = '2'
            req.price = data.price + 0.01

        req.clOrderNo = self.next_clOrderNo()
        ret = super().submit_order(req)
        if ret == 0:
            self.infolog_c(self.to_console, "PYTHON strategy: submit_order success.")
            self.clOrderNos[req.clOrderNo] = ""
        else:
            self.infolog_c(self.to_console, "PYTHON strategy: submit_order failed.")

        self.lastPrice = data.price

        time = super().get_HHMMSSsss()
        # self.lock.acquire()
        # try:
        for key in self.ordersUnFinish.keys():
            if self.ordersUnFinish[key] - time > 5000:
                ret = super().cancel_order(key, self.acctType, self.acct)
                if ret == 0:
                    self.infolog_c(self.to_console, "PYTHON strategy: cancel_order success.")
                else:
                    self.infolog_c(self.to_console, "PYTHON strategy: cancel_order failed.")
        # finally:
            # 修改完成，释放锁
            # self.lock.release()

    def on_order(self, data):
        self.infolog_c(self.to_console, "on_order >>>>>>>>>>>>")
        if data.clOrderNo in self.clOrderNos.keys():
            self.infolog_c(self.to_console, "on_order.clOrderNo=" + data.clOrderNo)
            self.clOrderNos[data.clOrderNo] = data.orderNo
        else:
            self.infolog_c(self.to_console, "on_order.unknown order:clOrderNo=" + data.clOrderNo + ",orderNo=" + data.orderNo)

        if data.status != 0 or data.status != 1:
            # self.lock.acquire()
            # try:
            if data.orderNo in self.ordersUnFinish:
                del self.ordersUnFinish[data.orderNo]
            # finally:
            #     # 修改完成，释放锁
            #     self.lock.release()

    def on_tran(self, data):
        self.infolog_c(self.to_console, "on_tran >>>>>>>>>>>>")

    def on_trade(self, data):
        self.infolog_c(self.to_console, "on_trade >>>>>>>>>>>>")

    def on_entrust(self, orderno, bsuccess, message, arg):
        self.infolog_c(self.to_console, "on_entrust >>>>>>>>>>>> {}".format(arg) )
        if bsuccess is True:
            now = super().get_HHMMSSsss()
            # self.lock.acquire()
            # try:
            self.ordersUnFinish[orderno] = now
            # finally:
            #     # 修改完成，释放锁
            #     self.lock.release()

    def on_cancel(self, orderno, bsuccess, message, arg):
        self.infolog_c(self.to_console, "on_cancel >>>>>>>>>>>>, arg:{}".format(arg))

    # def load_table_cb(self,  data, nlen):
    #     self.infolog_c(self.to_console, "load_table_cb >>>>>>>>>>>>name=" + data.name + "value=" + data.value + "nlen=" + str(nlen))

    def test_get_fund(self):
        fund = Fund()
        fundlist = [fund]
        ret = super().get_fund(fundlist, "S0", "bt00000")
        if ret == 0:
            self.infolog_c(self.to_console, "get_fund success")
        else:
            self.infolog_c(self.to_console, "get_fund fail")

    def test_get_position(self):
        position = Position()
        positionlist = [position]
        ret = super().get_position("600000.SH", positionlist)
        if ret == 0:
            self.infolog_c(self.to_console, "get_position success")
        else:
            self.infolog_c(self.to_console, "get_position fail")

    def test_get_tick_slice(self, date):
        ticks = self.get_tick_slice("600000.SH", date, 92500000, date, 93500000)
        if ticks is not None:
            for tick in ticks:
                self.infolog_c(self.to_console, "get_tick_slice >>>>>>>>>>>>" + tick.toString())

    def test_load_data(self):
        tables = [DataTable()]
        ret = super().load_table("AShareEODPrices", "600000.SH", "2021-07-01", "2021-07-10", "", "", tables)
        table = tables[0]
        if ret == 0:
            if len(table.rows) > 0:
                for i in range(len(table.rows)):
                    row = table.rows[i]
                    rowStr = ""
                    for j in range(len(row.fields)):
                        rowStr = rowStr + row.fields[j].name
                        rowStr = rowStr + "="
                        rowStr = rowStr + row.fields[j].value
                        if j < len(row.fields)-1:
                            rowStr = rowStr + ","
                    self.infolog_c(self.to_console, "load_data >>>>>>>>>>>>row["+str(i)+"]=" + rowStr)
        else:
            self.infolog_c(self.to_console, "load_data:failed, ret=" + str(ret))

    def test_load_data_to_data_frame(self):
        df = super().load_data_to_data_frame("AShareEODPrices", "600000.SH", "2021-07-01", "2021-07-10", "", "")
        print(df)

