package com.citics.cats.bt.samples;

import com.citics.cats.bt.CatsBtJavaCustomize;
import com.citics.cats.bt.datastruct.*;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;


public class CatsBtJavaDemoMain extends CatsBtJavaCustomize {

    public CatsBtJavaDemoMain(){}

    static boolean toConsole = false;
    static final  String acctType = "S0";
    static final  String acct = "bt00000";
    public static HashMap<String, Integer> ordersUnFinish =  new HashMap<>();
    public int count = 0;
    public int clOrderNo = 0;
    public static HashMap<String, String> clOrderNos =  new HashMap<>();
    public float lastPrice;

    public String nextClOrderNo() {
        clOrderNo++;
        return "clOrderNo-" + clOrderNo;
    }

    public int init(DataField[] dataFields, int nlen) {
        //setDebug(true);
        super.infoLog(toConsole, "JAVA Porter: [CatsBtJavaDemo]init>>>>>" + "nlen=" + nlen);
        for(int i = 0 ; i < nlen; i++) {
            super.infoLog(toConsole, "JAVA strategy,initParam: name=" + dataFields[i].name + ",value=" + dataFields[i].value + ",type=" + dataFields[i].type);
        }

//        setStartEndDay(20210801,20210806);
//        setStartEndTime(91500000,15000000,false);
        int[] dd = getStartEndDay();

        return 0;
    }

    public int onInit() {
        super.infoLog(toConsole, "JAVA Porter: [CatsBtJavaDemo]onInit>>>>>");
        super.subTicks("600000.SH");
        super.subBars("600000.SH");
        super.infoLog(toConsole, "JAVA Porter: [CatsBtJavaDemo]subTicks successful: symbol=600000.SH");

        super.subOrder(acctType, acct);
        super.subTrade(acctType, acct);

//        super.initFund(1000000, acctType, acct);
        super.initFund(1000000, 0, 0, 0, 0, 0.001, acctType, acct);

        super.initPosition("600000.SH", 100000, 9, acctType, acct);

        Fund fund = new Fund();
        for(int v = 0 ; v < 10 ;  v++) {
            int ret2 = super.getFund(fund, "S0", "bt00000");
            if (ret2 == 0)
                super.infoLog(toConsole, "JAVA Porter: [CatsBtJavaDemo]getFund success, fund=" + fund.toString());
            else
                super.infoLog(toConsole, "JAVA Porter: [CatsBtJavaDemo]getFund fail, fund=" + fund.toString());
        }

        ArrayList<Position> positionList = new ArrayList<Position>();
        int ret = super.getPositions(positionList, acctType, acct);
        if(ret == 0) {
            super.infoLog(toConsole, "JAVA Porter: [CatsBtJavaDemo]getPositions success");
            if(positionList.size()>0)
                for(Position position: positionList)
                    super.infoLog(toConsole, "positionList[]" + position.toString());
        } else {
            super.infoLog(toConsole, "JAVA Porter: [CatsBtJavaDemo]getPositions fail");
        }

        testLoadData();

        return 0;
    }

    public int onSessionBegin(int date){
        int dd = getYYYYMMDD();
        int hms = getHHMMSSsss();
        testGetTickSlice(dd);

        super.infoLog(toConsole, "JAVA Porter: [CatsBtJavaDemo]onSessionBegin>>>>>date=" + date);
        return 0;
    }

    public int onSessionEnd(int date){
        super.infoLog(toConsole, "JAVA Porter: [CatsBtJavaDemo]onSessionEnd>>>>>date=" + date);
        return 0;
    }

    public void onrReplayDone(){
        super.infoLog(toConsole, "JAVA Porter: [CatsBtJavaDemo]onReplayDone>>>>>");
    }

    public void onTick(TickStruct data){
        int current = getHHMMSSsss() / 1000;
        if (current < 93000){
            return;
        }
        count ++;
        if (count % 5 != 0){
            return;
        }

        if (data.price == lastPrice) {
            return;
        }
        else if(data.price < lastPrice){
            OrderRequest req = new OrderRequest();
            req.acctType = acctType;
            req.acct = acct;
            req.symbol = data.code;
            req.qty = 100 ;
            req.priceType = "0";
            req.tradeSide = "1";
            req.price = data.price - 0.01f ;
            req.clOrderNo = nextClOrderNo();
            int ret = super.submitOrder(req, "22222");
            if(ret == 0){
                clOrderNos.put(req.clOrderNo, "");
                super.infoLog(toConsole, "JAVA strategy: submitOrder success.");
            }else{
                super.infoLog(toConsole, "JAVA strategy: submitOrder failed.");
            }
        }
        else if(data.price > lastPrice){
            OrderRequest req = new OrderRequest();
            req.acctType = acctType;
            req.acct = acct;
            req.symbol = data.code;
            req.qty = 100 ;
            req.priceType = "0";
            req.tradeSide = "2";
            req.price = data.price + 0.01f ;
            req.clOrderNo = nextClOrderNo();
            int ret = super.submitOrder(req);
            if(ret == 0){
                super.infoLog(toConsole, "JAVA strategy: submitOrder success.");
                clOrderNos.put(req.clOrderNo, "");
            }else{
                super.infoLog(toConsole, "JAVA strategy: submitOrder failed.");
            }
        }
        lastPrice = data.price;
        int time = super.getHHMMSSsss();
        for(String key:ordersUnFinish.keySet()){
            if(ordersUnFinish.get(key) - time > 30000){
                int ret = super.cancelOrder(key,acctType, acct,"11111");
                if(ret==0) {
                    super.infoLog(toConsole, "JAVA strategy: cancelOrder success.");
                }
                else {
                    super.infoLog(toConsole, "JAVA strategy: cancelOrder failed.");
                }
            }
        }
    }

    public void onBar(BarStruct data){
        int current = getHHMMSSsss() / 1000;
        if (current < 93000){
            return;
        }
        count ++;
        if (count % 5 != 0){
            return;
        }

        if (data.close == lastPrice) {
            return;
        }
        else if(data.close < lastPrice){
            OrderRequest req = new OrderRequest();
            req.acctType = acctType;
            req.acct = acct;
            req.symbol = data.code;
            req.qty = 100 ;
            req.priceType = "0";
            req.tradeSide = "1";
            req.price = data.close - 0.01f ;
            req.clOrderNo = nextClOrderNo();
            int ret = super.submitOrder(req, "22222");
            if(ret == 0){
                clOrderNos.put(req.clOrderNo, "");
                super.infoLog(toConsole, "JAVA strategy: submitOrder success.");
            }else{
                super.infoLog(toConsole, "JAVA strategy: submitOrder failed.");
            }
        }
        else if(data.close > lastPrice){
            OrderRequest req = new OrderRequest();
            req.acctType = acctType;
            req.acct = acct;
            req.symbol = data.code;
            req.qty = 100 ;
            req.priceType = "0";
            req.tradeSide = "2";
            req.price = data.close + 0.01f ;
            req.clOrderNo = nextClOrderNo();
            int ret = super.submitOrder(req);
            if(ret == 0){
                super.infoLog(toConsole, "JAVA strategy: submitOrder success.");
                clOrderNos.put(req.clOrderNo, "");
            }else{
                super.infoLog(toConsole, "JAVA strategy: submitOrder failed.");
            }
        }
        lastPrice = data.close;
        int time = super.getHHMMSSsss();
        for(String key:ordersUnFinish.keySet()){
            if(ordersUnFinish.get(key) - time > 30000){
                int ret = super.cancelOrder(key,acctType, acct,"11111");
                if(ret==0) {
                    super.infoLog(toConsole, "JAVA strategy: cancelOrder success.");
                }
                else {
                    super.infoLog(toConsole, "JAVA strategy: cancelOrder failed.");
                }
            }
        }
    }

    public void onOrder(OrderUpdateData data){
        super.infoLog(toConsole, "JAVA Porter: [CatsBtJavaDemo]onOrder>>>>>");
        //super.infoLog(toConsole, data.toString());
        if(clOrderNos.containsKey(data.clOrderNo)) {
            super.infoLog(toConsole, "JAVA Porter:onOrder.clOrderNo=" + data.clOrderNo + ",orderNo=" + data.orderNo);
            clOrderNos.put(data.clOrderNo, data.orderNo);
        } else {
            super.infoLog(toConsole, "JAVA Porter:onOrder.unknown order:clOrderNo=" + data.clOrderNo + ",orderNo=" + data.orderNo);
        }
        if(data.status != 0 || data.status != 1)
            if(ordersUnFinish.containsKey(data.orderNo))
                ordersUnFinish.remove(data.orderNo);
    }

    public void onTran(TransData data){
//        super.infoLog(toConsole, "JAVA Porter: [CatsBtJavaDemo]onTran>>>>>");
    }

    public void onTrade(TradeData data){
         super.infoLog(toConsole, "JAVA Porter: [CatsBtJavaDemo]onTrade>>>>>");
         super.infoLog(toConsole, data.toString());
    }

    public void onEntrust(String orderNo, boolean bSuccess, String message, Object arg){
        super.infoLog(toConsole, "JAVA Porter: [CatsBtJavaDemo]onEntrust>>>>>orderNo:" + orderNo + ", bSuccess:" + bSuccess + ", message:" + message );
        if(bSuccess) {
            int now = super.getHHMMSSsss();
            ordersUnFinish.put(orderNo, now);
        }
        int ret = 0;
        if(orderNo.equals("L9")) {
            ret = super.cancelOrder(orderNo, acctType, acct);
            if (ret == 0) {
                super.infoLog(toConsole, "JAVA strategy: cancelOrder success.");
            } else {
                super.infoLog(toConsole, "JAVA strategy: cancelOrder failed.");
            }
        }
    }

    public void onCancel(String orderNo, boolean bSuccess, String message, Object arg){
        super.infoLog(toConsole, "JAVA Porter: [CatsBtJavaDemo]onCancel>>>>>orderNo:" + orderNo + ", bSuccess:" + bSuccess + ", message:" + message);
    }

    public void testGetFund(){
        Fund fund = new Fund();
        int ret2 = super.getFund(fund, "", "");
        if(ret2 == 0)
            super.infoLog(toConsole, "JAVA Porter: [CatsBtJavaDemo]getFund success, fund=" + fund.toString());
        else
            super.infoLog(toConsole, "JAVA Porter: [CatsBtJavaDemo]getFund fail, fund=" + fund.toString());

    }

    public void testGetTickSlice(int date){
        List<TickStruct> ticks = super.getTickSlice("600000.SH", date, 91500000, date, 150000000);
        if(ticks!=null && ticks.size()!=0){
            for(TickStruct tick : ticks)
                super.infoLog(toConsole, "getTickSlice >>>>>>>>>>>>" + tick.toString());
        }

    }

    public void testLoadData(){
        DataTable tables = new DataTable();
        int ret = super.loadTable("AShareEODPrices", "600000.SH", "2021-07-01", "2021-07-10","", "", tables);
        if(ret==0){
            for(int i = 0 ; i < tables.rows.size(); i++){
                DataRow row = tables.rows.get(i);
                String rowStr = "";
                for(int j = 0 ; j < row.fields.size(); j++){
                    rowStr = rowStr + row.fields.get(j).name;
                    rowStr = rowStr + "=";
                    rowStr = rowStr + row.fields.get(j).value;
                    if(j<row.fields.size()-1){
                        rowStr = rowStr + ",";
                    }
                }
                super.infoLog(toConsole, "loadTable >>>>>>>>>>>>row["+i+"]=" + rowStr);
            }
        }else{
            super.infoLog(toConsole, "loadTable:failed, ret=" + ret);
        }
    }



}

